/**
 * @file
 * Theme functions for the layout js-app.
 */
(function ($) {
  /**
   * Theme function for a region.
   * @param id
   * @param label
   * @return {String}
   */
  Drupal.theme.layoutRegion = function (id, label) {
    var html =
      '<div class="layout-region" id="layout-region-' + id + '">' +
        '<div class="region-wrapper">' +
          '<div class="region-header clearfix">' +
            '<div class="region-actions">' +
              '<div class="add-block"><span class="plus-icon"></span></div>' +
              '<div class="add-block"><span class="gear-icon"></span></div>' +
            '</div>' +
            '<div class="region-information"><span class="region-label">' + label + '</span></div>' +
          '</div>' +
          '<div class="region-table">' +
            '<div class="region-blocks"></div>'
          '</div>' +
        '</div>' +
      '</div>';
    return html;
  }

  /**
   * Theme function to get the html for a block instance.
   * @param id
   * @param label
   * @return {String}
   */
  Drupal.theme.layoutBlock = function (id, label, attributes) {
    return '<div class="block" id="block-' + id + '">' +
      '<div class="master-block">' +
        '<div class="block-information">' +
          '<span class="block-type-indicator mb-text">M</span>' +
          '<span class="block-label mb-text">' + id + '&nbsp;block</span>' +
        '</div>' +
        '<div class="mb-block-operations"><span class="gear mb-gear"></span></div>' +
      '</div>' +
     '</div>';
  };

})(jQuery);
