/**
 * @file
 * This view controls a single BlockInstance.
 */
(function ($, _, Backbone, Drupal) {

  "use strict";

  Drupal.layout = Drupal.layout || {};

  Drupal.layout.BlockInstanceView = Backbone.View.extend({
    events:{
      'click':'onClick',
      'drop':'onDrop'
    },
    onDrop:function (event, index) {
      // Trigger reorder, will be handled in Drupal.layout.RegionView.
      this.$el.trigger('reorder', [this.model, index]);
      // @todo: handle dropping onto enpty region.
      event.preventDefault();
      event.stopPropagation();
      return ;
    },
    onClick:function () {
      this.dialogView = new Drupal.layout.BlockInstanceModalView({
        model: this.model,
        title: this.model.get('label')
      });
      this.dialogView.render();
    },
    render:function () {
      this.setElement($(Drupal.theme('layoutBlock', this.model.get('id'), this.model.get('label'), this.model.attributes)));
      return this;
    }
  });


})(jQuery, _, Backbone, Drupal);
