(function ($, _, Backbone, Drupal) {

  "use strict";

  Drupal.layout = Drupal.layout || {};

  Drupal.layout.RegionsView = Backbone.View.extend({
    initialize:function () {
      this._collectionView = new Drupal.layout.UpdatingCollectionView({
        collection:this.collection,
        nestedViewConstructor:Drupal.layout.RegionView,
        nestedViewTagName:'div'
      });
    },

    render:function () {
      this.$el.empty();
      this._collectionView.setElement(this.$el);
      this._collectionView.render();
      return this;
    },

    remove:function () {
      this._collectionView.remove();
      this.$el.empty();
    }
  });


})(jQuery, _, Backbone, Drupal);
