(function ($, window, Drupal, drupalSettings) {

"use strict";

/**
 * Attach display editor functionality.
 */
Drupal.behaviors.displayEditor = {

  attach: function (context) {
    var appModel;

    function ExtractModelsFromDOM() {
      var regions = new Drupal.layout.RegionsCollection();
      // Retrieve regions from DOM.
      $('.layout-region').each(function() {
        var $region = $(this);
        var blockInstances = new Drupal.layout.BlockInstancesCollection();
        var weight = 0;
        // wow, this is awkward but will go away.
        var classes = $region.attr('class').split(' ');
        var pattern = new RegExp('layout-region-.+');
        var region_id = _.filter(classes, function(v) {
          return pattern.test(v);
        }).toString().replace('layout-region-', '');

        $region.find('.block').each(function() {
          var block = new Drupal.layout.BlockInstanceModel({
            id: $(this).attr('id').replace(/block-/, ''),
            blockId: 'default',
            label: $(this).find('.block-label').text(),
            region: region_id,
            weight: weight
          });
          weight++;
          blockInstances.add(block, {silent: true});
        });
        var region = new Drupal.layout.RegionModel({
          id: region_id,
          label: $region.find('.region-label').text(),
          blockInstances: blockInstances
        });
        regions.add(region);
      });
      return regions;
    }

    function randomId() {
      var chars = "abcdefghiklmnopqrstuvwxyz";
      var randomString = '';
      for (var i=0; i < 8; i++) {
        var rnum = Math.floor(Math.random() * chars.length);
        randomString += chars.substring(rnum,rnum+1);
      }
      return randomString;
    }

    Drupal.layout.getBlocksCollection = function() {
      var blocks = [];
      // Generate a bunch of randomly named blocks that.
      for (var i = 0; i<10; i++) {
        var id = randomId();
        var b = new Drupal.layout.BlockModel({
          'id': id,
          'label': 'Label ' + id
        });
        blocks.push(b);
      }
      return new Drupal.layout.BlocksCollection(blocks);
    }

    // @todo: make this work on template change, i.e. Drupal.ajax/behaviour compatible.
    Drupal.layout.appModel = new Drupal.layout.AppModel({
      id: drupalSettings.layout.id
    });
    // let's grab the stuff from DOM - it would be useful to have JSON ...
    Drupal.layout.appModel.set('regions', ExtractModelsFromDOM() );
    var appView = new Drupal.layout.AppView({
      model: Drupal.layout.appModel,
      el: $('#block-system-main'),
      settings: drupalSettings.layout
    });
    appView.render();
  }
};

})(jQuery, window, Drupal, drupalSettings);
