<?php

/**
 * @file
 * Definition of Drupal\page\PageListController.
 */

namespace Drupal\page;

use Drupal\Core\Config\Entity\ConfigEntityListController;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Entity\EntityStorageControllerInterface;
use Drupal\page\Plugin\Core\Entity\Page;

/**
 * Provides a listing of pages.
 */
class PageListController extends ConfigEntityListController {

  /**
   * Overrides Drupal\Core\Entity\EntityListController::buildHeader();
   *
   * Replace machine name with path and layout.
   */
  public function buildHeader() {
    $row['label'] = t('Title');
    $row['paths'] = t('Path');
    $row['layout'] = t('Layout');
    $row['operations'] = t('Operations');
    return $row;
  }

  /**
   * Overrides Drupal\Core\Entity\EntityListController::buildRow();
   *
   * Replace machine name with path and layout.
   */
  public function buildRow(EntityInterface $entity) {
    $row['label'] = l($entity->label(), $entity->path);
    $row['path'] = check_plain($entity->path);
    $layout = drupal_container()->get('plugin.manager.layout')->getDefinition($entity->layout);
    $row['layout'] = check_plain($layout['title']);
    $operations = $this->buildOperations($entity);
    $row['operations']['data'] = $operations;
    return $row;
  }

}
